//
//  BKConfigurationProtocols.h
//  Blocks
//
//  Created by «FULLUSERNAME» on «DATE».
//  Copyright «YEAR» «ORGANIZATIONNAME». All rights reserved.
//	2008-01-02	-<BKConfigurationDelegateProtocol> applicationSoftwareUpdateNotesURLString -	Added to supply the URL to the release notes for the Software Update subsystem.
//
#import <Cocoa/Cocoa.h>

@class	ASCVersion;

typedef enum {
    BKConfigurationLoggingOff = 99,
    BKConfigurationLoggingFatal = 50,
    BKConfigurationLoggingError = 40,
    BKConfigurationLoggingWarn = 30,
    BKConfigurationLoggingInfo = 20,
    BKConfigurationLoggingDebug = 10,
    BKConfigurationLoggingAll = 0,
} BKConfigurationLoggingLevel;

@protocol BKConfigurationControllerProtocol <NSObject>

- (BKConfigurationLoggingLevel)loggingLevel;
- (void)setLoggingLevel:(BKConfigurationLoggingLevel)level;
- (NSDate *)lastRunDate;
- (ASCVersion *)lastRunVersion;
- (ASCVersion *)currentRunVersion;
- (ASCVersion *)OSVersion;
- (IBAction)showUserGuide:(id)sender;
- (IBAction)visitWebPage:(id)sender;
- (IBAction)visitUserForums:(id)sender;
- (IBAction)recoverLostLicense:(id)sender;
- (IBAction)showReleaseNotes:(id)sender;
- (IBAction)pluginsAndScripts:(id)sender;
- (IBAction)requestNewFeatureOrReportBug:(id)sender;

@end

@protocol BKConfigurationDelegateProtocol <NSObject>

- (NSData *)applicationPublicKey;
- (NSString *)applicationLicenseName;
- (NSString *)applicationUserGuideURLString;
- (NSString *)applicationWebPageURLString;
- (NSString *)applicationUserForumsURLString;
- (NSString *)applicationRecoverLostLicenseURLString;
- (NSString *)applicationPluginsAndScriptsURLString;
- (NSString *)applicationReleaseNotesURLString;
- (NSString *)applicationRequestsAndBugsURLString;
- (NSString *)applicationDownloadURLString;
- (NSString *)applicationSoftwareUpdateURLString;
- (NSString *)applicationSoftwareUpdateNotesURLString;
- (NSString *)applicationCrashReportURLString;
- (NSString *)applicationUpgradeDonationURLString;
- (NSString *)applicationBuyNowURLString;

@end

@interface NSApplication (BKConfigurationControllerProtocolAccess)
- (id <BKConfigurationControllerProtocol>)BKConfigurationProtocols_configurationController; // exposed this way for applescript support
@end
